"use strict";
///<reference path="./types.d.ts" />
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs");
var frontEndApis = require('./frontEndApis').frontEndApis;
var TplSection = /** @class */ (function () {
    function TplSection(content, params, symbols) {
        this.content = content;
        this.params = params;
        this.symbols = symbols;
    }
    return TplSection;
}());
var MacroResult = /** @class */ (function () {
    function MacroResult(content, doBreak, disconnect, headers) {
        if (doBreak === void 0) { doBreak = false; }
        if (disconnect === void 0) { disconnect = false; }
        if (headers === void 0) { headers = {}; }
        this.content = content;
        this.doBreak = doBreak;
        this.disconnect = disconnect;
        this.headers = headers;
    }
    return MacroResult;
}());
var UniParam = /** @class */ (function () {
    function UniParam(params, symbols, ctx) {
        if (symbols === void 0) { symbols = {}; }
        this.params = params;
        this.symbols = symbols;
        this.ctx = ctx;
    }
    return UniParam;
}());
var Page = /** @class */ (function () {
    function Page(content, status, headers) {
        if (headers === void 0) { headers = {}; }
        this.content = content;
        this.status = status;
        this.headers = headers;
    }
    return Page;
}());
function smartSize(size) {
    var units = ['', 'K', 'M', 'G', 'T', 'P', 'E'];
    var result = size;
    for (var i = 0; i < units.length; i++) {
        if (result < 1024) {
            var precised = Math.round(result * 10) / 10;
            return "".concat(precised, " ").concat(units[i]);
        }
        result = result / 1024;
    }
}
var Template = /** @class */ (function () {
    function Template(path) {
        var _this = this;
        if (path === void 0) { path = 'hfs.tpl'; }
        this._regex = {
            meta: /^([\+\^]?)(.*?)(\|.*)?$/
        };
        this.symbols = {
            'files': function (p) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/, new MacroResult(this.sections.files.content)];
            }); }); },
            'list': function (p) { return __awaiter(_this, void 0, void 0, function () {
                var _a;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = MacroResult.bind;
                            return [4 /*yield*/, frontEndApis.file_list({ path: p.ctx.path, sse: '0', omit: 'c' }, p.ctx)];
                        case 1: return [2 /*return*/, new (_a.apply(MacroResult, [void 0, (_b.sent()).list.map(function (entry) {
                                    var new_p = new UniParam(p.params, {
                                        itemUrl: function (p) { return new MacroResult(encodeURI(p.ctx.path) + encodeURIComponent(entry.n)); },
                                        itemName: function (p) { return new MacroResult(entry.n); },
                                        itemModified: function (p) { return new MacroResult(entry.m ? "".concat(entry.m.getMonth() + 1, "/").concat(entry.m.getDay(), "/").concat(entry.m.getFullYear()) : ''); },
                                        itemSize: function (p) { return new MacroResult(smartSize(entry.s)); }
                                    }, p.ctx);
                                    var f = (entry.s === undefined ? _this.symbols._folder : _this.symbols._file);
                                    return f(new_p).content;
                                }).join('')]))()];
                    }
                });
            }); },
            '_file': function (p) { return new MacroResult(_this.sections.file.content
                .replace('%item-url%', p.symbols.itemUrl(p).content)
                .replace('%item-name%', p.symbols.itemName(p).content)
                .replace('%item-modified%', p.symbols.itemModified(p).content || '-')
                .replace('%item-size%', p.symbols.itemSize(p).content || '-')); },
            '_folder': function (p) { return new MacroResult(_this.sections.folder.content
                .replace('%item-url%', p.symbols.itemUrl(p).content)
                .replace('%item-name%', p.symbols.itemName(p).content)
                .replace('%item-modified%', p.symbols.itemModified(p).content || '-')
                .replace('%item-size%', p.symbols.itemSize(p).content || '-')); }
        };
        this._raw = '\n' + fs.readFileSync(path, { encoding: 'utf8', flag: 'r' });
        this.sections = {};
        var raw_parts = this._raw.split('\n[');
        this.sections[''] = new TplSection(raw_parts.shift(), [], {});
        for (var _i = 0, raw_parts_1 = raw_parts; _i < raw_parts_1.length; _i++) {
            var raw_part = raw_parts_1[_i];
            var _a = raw_part.split(']\n'), meta = _a[0], _data_parts = _a.slice(1);
            var data = _data_parts.join(']\n');
            var _b = meta.match(this._regex.meta), _plus = _b[1], _names = _b[2], _params = _b[3];
            var plus = (_plus == '+' ? 1 : _plus == '^' ? 2 : 0), names = _names.split('='), params = _params ? _params.split('|') : [];
            for (var _c = 0, names_1 = names; _c < names_1.length; _c++) {
                var name_1 = names_1[_c];
                if (this.sections[name_1] === undefined || !plus)
                    this.sections[name_1] = new TplSection(plus ? '' : data, params, {});
                if (plus) {
                    if (plus == 1)
                        this.sections[name_1].content += data;
                    else if (plus == 2)
                        this.sections[name_1].content = data + this.sections[name_1].content;
                }
            }
        }
    }
    Template.prototype.getText = function (content, param) {
        return __awaiter(this, void 0, void 0, function () {
            var old_content, _a, _b, _i, sym, _c, _d, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        old_content = null;
                        _f.label = 1;
                    case 1:
                        if (!(content != old_content)) return [3 /*break*/, 6];
                        _a = [];
                        for (_b in this.symbols)
                            _a.push(_b);
                        _i = 0;
                        _f.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        sym = _a[_i];
                        if (!(content.indexOf('%' + sym + '%') >= 0)) return [3 /*break*/, 4];
                        _d = (_c = content).replace;
                        _e = ['%' + sym + '%'];
                        return [4 /*yield*/, this.symbols[sym](param)];
                    case 3:
                        content = _d.apply(_c, _e.concat([(_f.sent()).content]));
                        _f.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        old_content = content;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, new MacroResult(content)];
                }
            });
        });
    };
    Template.prototype.getSection = function (name, param, doParse, force) {
        return __awaiter(this, void 0, void 0, function () {
            var content, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!this.sections[name])
                            return [2 /*return*/, null];
                        content = this.sections[name].content;
                        if (!doParse) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getText(content, param)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = new MacroResult(content);
                        _b.label = 3;
                    case 3: return [2 /*return*/, _a];
                }
            });
        });
    };
    Template.prototype.serve = function (ctx) {
        return __awaiter(this, void 0, void 0, function () {
            var result, page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!ctx.path.endsWith('/')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getSection('', new UniParam([], {}, ctx), true, false)];
                    case 1:
                        result = _a.sent();
                        page = new Page(result.content, 200, result.headers);
                        ctx.status = page.status;
                        ctx.set(page.headers);
                        ctx.type = 'html';
                        ctx.body = page.content;
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    return Template;
}());
module.exports = Template;
